﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CheckBoxListTester
{
    public partial class Form1 : Form
    {
        private int height = 0;
        public Form1()
        {
            InitializeComponent();

            this.AddControl("1 Some text");

            this.AddControl("2 Some text which will show the UserControl dynamically resize to fit the text");
            
            this.AddControl("3 Some more text");

            this.AddControl("4 Some text which will show the UserControl dynamically resize to fit the text");

            this.AddControl("5 Some more text");

            this.AddControl("6 Some text which will show the UserControl dynamically resize to fit the text");

            this.AddControl("7 Some more text");

            this.AddControl("8 Some text which will show the UserControl dynamically resize to fit the text");

            this.AddControl("9 Some more text");

            this.AddControl("10 Some text which will show the UserControl dynamically resize to fit the text");

            this.AddControl("11 Some more text");

            this.AddControl("12 Some text which will show the UserControl dynamically resize to fit the text");

            this.AddControl("13 Some more text");

            this.AddControl("14 Some text which will show the UserControl dynamically resize to fit the text");

            this.panel2.Height = height;

            this.vScrollBar1.Top = this.panel2.Top;
            this.vScrollBar1.Maximum = this.panel2.Height - this.panel1.Height;
        }
        
        private void AddControl(string text)
        {
            Control previousControl = null;

            // Get the last control so base the next control's position on
            if (this.panel2.Controls.Count > 0)
            {
                previousControl = this.panel2.Controls[this.panel2.Controls.Count - 1];
            }

            CheckBoxTextBox currentControl = new CheckBoxTextBox();
            currentControl.Left = 3;
            currentControl.Text = text;
            currentControl.Width = this.panel2.Width - 6;

            if (previousControl == null)
            {
                currentControl.Top = 3;
            }
            else
            {
                currentControl.Top = previousControl.Top + previousControl.Height + 3;
            }

            this.panel2.Controls.Add(currentControl);

            height = currentControl.Top + currentControl.Height + (this.panel2.Controls.Count * 3);
        }

        private void vScrollBar1_ValueChanged(object sender, EventArgs e)
        {
            this.panel2.Top = 0 - this.vScrollBar1.Value;
        }
    }
}